; 
    include \masm32\include\masm32rt.inc
    .686
    include counter2.asm
; 
    .data
      nrand_seed  dd 1
      seq         dd 10 dup(0)

      include rns.asm
    .code
; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4
nrand proc base:DWORD
    mov ecx, nrand_seed
    mov edx, ecx
    sar edx, 16
    imul edx, edx, 16807
    movzx eax, cx
    imul eax, eax, 16807
    mov ecx, edx
    shr edx, 15
    and ecx, 32767
    sal ecx, 16
    add eax, ecx
    add eax, edx
    js  L2
  L1:
    xor edx, edx
    mov nrand_seed, eax
    div dword ptr[esp+4]
    mov eax, edx
    ret 4
  L2:
    sub eax, 2147483647
    jmp L1
nrand endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

nrand_period proc
    xor ebx, ebx
    .WHILE ebx < 10
      invoke nrand,0ffffffffh
      mov [seq+ebx*4], eax
      inc ebx
    .ENDW
    xor ebx, ebx
    .WHILE ebx < 0ffffffffh
      invoke nrand,0ffffffffh
      .IF eax == seq
        mov esi, eax
        print "duplication @ "
        print ustr$(ebx),13,10
        print ustr$(esi),9
        print ustr$(esi),13,10
        mov esi, 1
        .WHILE esi < 10
          print ustr$([seq+esi*4]),9
          invoke nrand,0ffffffffh
          print ustr$(eax),13,10
          inc esi
        .ENDW
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    ret
nrand_period endp

; 

nrandom_period proc
    xor ebx, ebx
    .WHILE ebx < 10
      invoke nrandom,0ffffffffh
      mov [seq+ebx*4], eax
      inc ebx
    .ENDW
    xor ebx, ebx
    .WHILE ebx < 0ffffffffh
      invoke nrandom,0ffffffffh
      .IF eax == seq
        mov esi, eax
        print "duplication @ "
        print ustr$(ebx),13,10
        print ustr$(esi),9
        print ustr$(esi),13,10
        mov esi, 1
        .WHILE esi < 10
          print ustr$([seq+esi*4]),9
          invoke nrandom,0ffffffffh
          print ustr$(eax),13,10
          inc esi
        .ENDW
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    ret
nrandom_period endp

; 
start:
; 

    ; --------------------------------------------------
    ; Verify that first 1000 values from the generated
    ; sequence match the sequence from a known-good
    ; implementation.
    ; --------------------------------------------------

    print "Verifying sequence..."
    xor ebx, ebx
    .WHILE ebx < 1000
      invoke nrand, 256
      .IF [rns+ebx*4] != eax
        print "mismatch @ "
        print ustr$(ebx),13,10
        .BREAK
      .ENDIF
      inc ebx
    .ENDW
    .IF ebx == 1000
      print "OK",13,10,13,10
    .ENDIF

    mov nrand_seed, 1
    invoke nseed,1
    invoke Sleep, 2000

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke nrandom, 100
    ctr_end
    print ustr$(eax)," cycles, nrandom",13,10

    ctr_begin 1000, HIGH_PRIORITY_CLASS
      invoke nrand, 100
    ctr_end
    print ustr$(eax)," cycles, nrand",13,10,13,10

    inkey "Press any key to continue...",13,10

    ; --------------------------
    ; Test the bad seed values.
    ; --------------------------

    mov nrand_seed, 0
    invoke nseed, 0
    print "Testing nrand with seed = 0..."
    call nrand_period
    inkey "Press any key to continue...",13,10
    print "Testing nrandom with seed = 0..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    mov nrand_seed, 2147483647
    invoke nseed, 2147483647
    print "Testing nrand with seed = 2147483647..."
    call nrand_period
    inkey "Press any key to continue...",13,10
    print "Testing nrandom with seed = 2147483647..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    ; ---------------------------------------------------
    ; Determine the periods for the first and last good
    ; seeds. This will take a while on a slow system.
    ; ---------------------------------------------------

    mov nrand_seed, 1
    invoke nseed, 1

    print "Determining nrand period with seed = 1..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Determining nrandom period with seed = 1..."
    call nrandom_period
    inkey "Press any key to continue...",13,10
    
    mov nrand_seed, 2147483646
    invoke nseed, 2147483646

    print "Determining nrand period with seed = 2147483646..."
    call nrand_period
    inkey "Press any key to continue...",13,10

    print "Determining nrandom period with seed = 2147483646..."
    call nrandom_period
    inkey "Press any key to continue...",13,10

    inkey "Press any key to exit..."
    exit
; 
end start
